
;ncmTest - DednDave, 7-2011

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .LIST

;###############################################################################################

MbPrint MACRO   arg1:REQ,varname:VARARG

        mov     esi,reparg(arg1)
        call    StrCopy

        IFNB    <varname>
        mov     esi,chr$(varname)
        call    StrCopy
        ENDIF

        ENDM

;***********************************************************************************************

MbNewLine MACRO

        mov     ax,10
        stosw
        dec     edi

        ENDM

;###############################################################################################

        .DATA

ClassName db 'ncmTestClass',0
AppName   db 'NONCLIENTMETRICS Structure Size Test',0
szVersion db 'OS Version: ',0
szSize    db 'Structure Size: ',0
szStatus  db 'SPI Status: ',0
szClip    db '(Use Ctrl-Insert to Copy to ClipBoard)',0

;------------------------------

        .DATA?

        ALIGN   4

hInstance dd ?
hWin      dd ?
Buff      db 256 dup(?)

;###############################################################################################

        .CODE

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;------------------------------

        mov     ecx,[esp+8]                      ;uMsg
        mov     edx,[esp+4]                      ;hWnd
        cmp     ecx,WM_CLOSE
        jz      WndPrY

        cmp     ecx,WM_DESTROY
        jz      WndPrZ

        cmp     ecx,WM_CREATE
        jnz     DefWindowProc

;------------------------------

;WM_CREATE

        mov     hWin,edx
        xor     eax,eax
        ret     16

;------------------------------

;WM_CLOSE

WndPrY: INVOKE  DestroyWindow,edx
        xor     eax,eax
        ret     16

;------------------------------

;WM_DESTROY

WndPrZ: INVOKE  PostQuitMessage,NULL
        xor     eax,eax
        ret     16

;------------------------------

WndProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;***********************************************************************************************

ncmThrd PROC

        sub     esp,sizeof NONCLIENTMETRICS+4
        mov     ebp,esp
        mov     edi,offset Buff

        MbPrint offset szVersion
        mov dword ptr [ebp],sizeof OSVERSIONINFO
        INVOKE  GetVersionEx,ebp
        mov     eax,[ebp].OSVERSIONINFO.dwMajorVersion
        MbPrint ustr$(eax),46
        mov     eax,[ebp].OSVERSIONINFO.dwMinorVersion
        MbPrint ustr$(eax),46
        mov     eax,[ebp].OSVERSIONINFO.dwBuildNumber
        MbPrint ustr$(eax),32
        lea     eax,[ebp].OSVERSIONINFO.szCSDVersion
        MbPrint eax
        MbNewLine

        mov     ebx,sizeof NONCLIENTMETRICS
        call    SpiTest

        add     ebx,4
        call    SpiTest

        MbNewLine
        MbPrint offset szClip

        INVOKE  MessageBox,hWin,offset Buff,offset AppName,MB_ICONQUESTION

        add     esp,sizeof NONCLIENTMETRICS+4
        INVOKE  ExitThread,0

ncmThrd ENDP

;***********************************************************************************************

SpiTest PROC

        MbPrint offset szSize
        MbPrint ustr$(ebx),32,32
        MbPrint offset szStatus
        mov     [ebp],ebx
        INVOKE  SystemParametersInfo,SPI_GETNONCLIENTMETRICS,ebx,ebp,NULL
        MbPrint uhex$(eax)
        MbNewLine
        ret

SpiTest ENDP

;***********************************************************************************************

StrCopy PROC

SCopy0: lodsb
        or      al,al
        stosb
        jnz     SCopy0

        dec     edi
        ret

StrCopy ENDP

;***********************************************************************************************

_main   PROC

;------------------------------

;initialize common controls

        push    ICC_WIN95_CLASSES
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp

;------------------------------

;register the window class

        xor     edi,edi
        INVOKE  LoadIcon,edi,IDI_APPLICATION
        push    eax                                     ;WNDCLASSEX.hIconSm
        xchg    eax,ebx                                                           ;save hIcon in EBX for later
        mov     esi,offset ClassName                                              ;ClassName address in ESI
        push    esi                                     ;WNDCLASSEX.lpszClassName
        push    edi                                     ;WNDCLASSEX.lpszMenuName
        push    COLOR_SCROLLBAR+1                       ;WNDCLASSEX.hbrBackground
        INVOKE  LoadCursor,edi,IDC_ARROW
        push    eax                                     ;WNDCLASSEX.hCursor
        push    ebx                                     ;WNDCLASSEX.hIcon
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        push    eax                                     ;WNDCLASSEX.hInstance
        xchg    eax,ebx                                                           ;now, EBX = hInstance
        push    edi                                     ;WNDCLASSEX.cbWndExtra
        push    edi                                     ;WNDCLASSEX.cbClsExtra
        push    WndProc                                 ;WNDCLASSEX.lpfnWndProc
        push    edi                                     ;WNDCLASSEX.style
        push    sizeof WNDCLASSEX                       ;WNDCLASSEX.cbSize
        INVOKE  RegisterClassEx,esp

;------------------------------

;create the window

        INVOKE  CreateWindowEx,edi,esi,offset AppName,
                WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN,
                CW_USEDEFAULT,SW_SHOWNORMAL,400,300,edi,edi,ebx,edi
        INVOKE  UpdateWindow,eax

;------------------------------

;non-client metrics structure size test thread

        INVOKE  CreateThread,edi,edi,ncmThrd,edi,edi,edi

;------------------------------

;message loop

        mov     ebp,esp
        jmp short mLoop1

mLoop0: INVOKE  TranslateMessage,ebp
        INVOKE  DispatchMessage,ebp

mLoop1: INVOKE  GetMessage,ebp,edi,edi,edi
        neg     eax                                ;exit only
        shr     eax,1                              ;if 0 or -1
        jnz     mLoop0                             ;otherwise, we loop

;------------------------------

;exit program

        pop     eax                                ;MSG.wParam is the parm for ExitProcess
        JMP     ExitProcess

_main   ENDP

;###############################################################################################

        END     _main

